package RaceLines
{
	function player::damage(%obj, %sourceObject, %position, %damage, %damageType)
	{
		if($DamageType_Array[%damageType] $= "Suicide" && isObject(%obj.getControlObject()) && %obj.client.lap !$= "")
			%obj.SSKRespawn();
		else
			parent::damage(%obj, %sourceObject, %position, %damage, %damageType);
	}
	function vehicleData::onEnterLiquid(%a, %obj, %coverage, %type)
	{
		if(%obj.getClassName() $= "WheeledVehicle" || %obj.getClassName() $= "FlyingVehicle")
		{
			%player = %obj.getControllingObject();
			if(isObject(%player))
				%player.SSKRespawn(%obj);
		}
		parent::onEnterLiquid(%a, %obj, %coverage, %type);
	}
	function player::SSKRespawn(%player)
	{
		%this = %player.client;
		%veh = %player.getControlObject();
		%veh.setVelocity("0 0 0");
		%veh.setTransform(%this.restorePoint);
		%veh.setDamageLevel(0);
	}
	function trigger::lapCheck(%tr,%veh)
	{
		%obj = %veh.getControllingObject();
		%this = %obj.client;
		if(%this.checkpoint $= "")
		{
			%this.checkpoint = %tr.check;
			%this.lap ++;
			%this.restorePoint = %veh.getTransform();
			if(%this.lap <= SSK.LapCount)
			{
				commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC%this.lap@"/"@SSK.LapCount@"\n\c3Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount@"\n\c3Health\c6:" SPC %maxHealth - %veh.getDamageLevel()@"/"@%maxHealth,3);
				SSK.runCheckTest(%this);
			}
		}
		if(%this.checkpoint < %tr.check)
		{
			%this.checkpoint++;
			%this.restorePoint = %veh.getTransform();
			commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC %this.lap@"/"@SSK.LapCount@"\n\c3Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount@"\n\c3Health\c6:" SPC %maxHealth - %veh.getDamageLevel()@"/"@%maxHealth,3);
		}
		if(%this.checkpoint >= SSK.CheckPointCount && %tr.check == 0)
		{
			%this.checkpoint = %tr.check;
			%this.lap ++;
			%this.restorePoint = %veh.getTransform();
			if(%this.lap <= SSK.LapCount)
				commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC %this.lap@"/"@SSK.LapCount@"\n\c3Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount@"\n\c3Health\c6:" SPC %maxHealth - %veh.getDamageLevel()@"/"@%maxHealth,3);
		}
		if(%this.lap > SSK.LapCount)
		{
			SSK.resetPlayers();
		}
	}
	function raceTrigger::onEnterTrigger(%this,%trigger,%obj)
	{
		if(%obj.getClassName() $= "WheeledVehicle" || %obj.getClassName() $= "FlyingVehicle" || %obj.getClassName() $= "AIPlayer")
			%trigger.lapCheck(%obj);
	}
	function brickSpeedkartCheckPointData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function brickSpeedkartStartLineData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function fxDTSBrick::setNTObjectName(%obj,%name)
	{
		if(%obj.getDataBlock().uiName $= "Checkpoint Brick")
		{
			%obj.area.check = %name;
			if(%name > SSK.CheckPointCount)
				SSK.CheckPointCount = %name;
		}
		parent::setNTObjectName(%obj,%name);
		if(%obj.getDataBlock().uiName $= "Checkpoint Brick")
			if(!isObject(%obj.area))
				%obj.createCheckpoint();
	}
	function fxDTSBrick::createCheckpoint(%obj)
	{
		%P1 = getWords(%obj.getWorldBox(),0,2);
		%P2 = getWords(%obj.getWorldBox(),3,5);
		%X1 = getWord(%P1,0);
		%X2 = getWord(%P2,0);
		%Y1 = getWord(%P1,1);
		%Y2 = getWord(%P2,1);
		%Z1 = getWord(%P1,2);
		%Z2 = getWord(%P2,2);
		if(%Y1 + 16 == %Y2)
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z*2;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		else
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z*2;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		%tr = new trigger()
		{
			position = %pos;
			polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
			dataBlock = raceTrigger;
			brick = %obj;
			startLine = false;
			check = 0;
		};
		%tr.setScale(%scale);
		%obj.area = %tr;
		%obj.setNTObjectName(getSubStr(%obj.getName(),1,strlen(%obj.getName())));
	}
	function fxDTSBrick::createStartLine(%obj)
	{
		%P1 = getWords(%obj.getWorldBox(),0,2);
		%P2 = getWords(%obj.getWorldBox(),3,5);
		%X1 = getWord(%P1,0);
		%X2 = getWord(%P2,0);
		%Y1 = getWord(%P1,1);
		%Y2 = getWord(%P2,1);
		%Z1 = getWord(%P1,2);
		%Z2 = getWord(%P2,2);
		if(%Y1 + 16 == %Y2)
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		else
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		%tr = new trigger()
		{
			position = %pos;
			polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
			dataBlock = raceTrigger;
			brick = %obj;
			startLine = true;	
			check = 0;
		};
		%tr.setScale(%scale);
		%obj.area = %tr;
	}
	function brickSpeedkartStartLineData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartStartLineData.getID())
			%that.schedule(1, createStartLine);
		parent::onPlant(%this,%that);
	}
	function brickSpeedkartCheckPointData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartCheckPointData.getID())
			%that.schedule(1, createCheckpoint);
		parent::onLoadPlant(%this,%that);
	}
	function detectPos(%v)
	{
		if(%v < 0)
		%v *= -1;
		return %v;
	}
};
activatePackage(RaceLines);