exec("./Datablocks.cs");
registerInputEvent("fxDTSBrick","onRaceVictory","Self fxDTSBrick" TAB "Vehicle Vehicle" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Vehicle_Owner(Player) Player" TAB "Vehicle_Owner(Client) GameConnection" TAB "Brick_Owner(Player) Player" TAB "Brick_Owner(Client) GameConnection");
registerInputEvent("fxDTSBrick","onCrossPoint","Self fxDTSBrick" TAB "Vehicle Vehicle" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Vehicle_Owner(Player) Player" TAB "Vehicle_Owner(Client) GameConnection" TAB "Brick_Owner(Player) Player" TAB "Brick_Owner(Client) GameConnection");
registerOutputEvent("Vehicle", changeVehicle, "datablock Vehicle");
registerOutputEvent("Player", checkpointRespawn);
registerOutputEvent("Vehicle", checkpointRespawn);
if(!isObject(SSK))
{
	new ScriptObject(SSK)
	{
		LapCount = 3;
		RoundCount = 3;
		CheckPointCount = 0;
		CurrentLead = "";
		TrackCount = 0;
	};
	if(!isObject(checkPointSimGroup))
		new SimSet(checkPointSimGroup);
	
	SSK.pointGroup = checkPointSimGroup;
}
function SSK_BuildTrackList()
{
	%pattern = "Add-Ons/SuperKart_*/save.bls";
	%file = findFirstFile(%pattern);
	while(%file !$= "")
	{
		SSK.Tracks[SSK.TrackCount] = %file;
		SSK.TrackCount ++;

		%file = findNextFile(%pattern);
	}
}

function SSK_DumpTrackList()
{
	echo("");
	if(SSK.TrackCount == 1)
		echo("1 track");
	else
		echo(SSK.TrackCount @ " tracks");
	for(%i = 0; %i < SSK.TrackCount; %i++)
	{
		%displayName = SSK.Tracks[%i];
		%displayName = strReplace(%displayName, "Add-Ons/SuperKart_", "");
		%displayName = strReplace(%displayName, "/save.bls", "");
		%displayName = strReplace(%displayName, "_", " ");

		if(%i == SSK.CurrentTrack)
			echo(" >" @ %displayName);
		else
			echo("  " @ %displayName);
	}
	echo("");
}

function SSK_NextTrack()
{
	SSK.CurrentTrack = mFloor(SSK.CurrentTrack);
	SSK.CurrentTrack++;
	SSK.CurrentTrack = SSK.CurrentTrack % SSK.TrackCount;

	SSK.ResetCount = 0;

	SSK_LoadTrack_Phase1(SSK.Tracks[SSK.CurrentTrack]);
}

function SSK_LoadTrack_Phase1(%filename)
{
	//suspend minigame resets
	SSK.MapChange = 1;

	//put everyone in observer mode
	%mg = $DefaultMiniGame;
	if(!isObject(%mg))
	{
		error("ERROR: SSK_LoadTrack( " @ %filename  @ " ) - default minigame does not exist");
		return;
	}
	for(%i = 0; %i < %mg.numMembers; %i++)
	{
		%client = %mg.member[%i];
		%player = %client.player;
		if(isObject(%player))
		 %player.delete();

		%camera = %client.camera;
		%camera.setFlyMode();
		%camera.mode = "Observer";
		%client.setControlObject(%camera);
	}

	//clear all bricks 
	// note: this function is deferred, so we'll have to set a callback to be triggered when it's done
	BrickGroup_888888.chaindeletecallback = "SSK_LoadTrack_Phase2(\"" @ %filename @ "\");";
	BrickGroup_888888.chaindeleteall();
}

function SSK_LoadTrack_Phase2(%filename)
{
	echo("Loading speedkart track " @ %filename);
	SSK.CheckPointCount = 0;
	SSK.pointGroup.delete();
	SSK.pointGroup = new SimSet(checkPointSimGroup);

	%displayName = %filename;
	%displayName = strReplace(%displayName, "Add-Ons/SuperKart_", "");
	%displayName = strReplace(%displayName, "/save.bls", "");
	%displayName = strReplace(%displayName, "_", " ");

	%loadMsg = "\c5Now loading \c6" @ %displayName;

	//read and display credits file, if it exists
	// limited to one line
	%creditsFilename = filePath(%fileName) @ "/credits.txt";
	if(isFile(%creditsFilename))
	{
		%file = new FileObject();
		%file.openforRead(%creditsFilename);

		%line = %file.readLine();
		%line = stripMLControlChars(%line);
		%loadMsg = %loadMsg @ "\c5, created by \c6" @ %line;

		%file.close();
		%file.delete();
	}

	messageAll('', %loadMsg);

	//load environment if it exists
	%envFile = filePath(%fileName) @ "/environment.txt"; 
	if(isFile(%envFile))
	{  
		//echo("parsing env file " @ %envFile);
		//usage: GameModeGuiServer::ParseGameModeFile(%filename, %append);
		//if %append == 0, all minigame variables will be cleared 
		%res = GameModeGuiServer::ParseGameModeFile(%envFile, 1);

		EnvGuiServer::getIdxFromFilenames();
		EnvGuiServer::SetSimpleMode();

		if(!$EnvGuiServer::SimpleMode)     
		{
			EnvGuiServer::fillAdvancedVarsFromSimple();
			EnvGuiServer::SetAdvancedMode();
		}
	}

	//load save file
	schedule(10, 0, serverDirectSaveFileLoad, %fileName, 3, "", 2, 1);
}


//some horrible /commands to change tracks and such
function serverCmdTrackList(%client)
{
	for(%i = 0; %i < SSK.TrackCount; %i++)
	{
		%displayName = SSK.Tracks[%i];
		%displayName = strReplace(%displayName, "Add-Ons/SuperKart_", "");
		%displayName = strReplace(%displayName, "/save.bls", "");
		%displayName = strReplace(%displayName, "_", " ");

		if(%i == SSK.CurrentTrack)
			messageClient(%client, '', " >" @ %i @ ". \c6" @ %displayName);
		else
			messageClient(%client, '', "  " @ %i @ ". \c6" @ %displayName);
	}
}
function serverCmdSetTrack(%client, %i)
{
	if(!%client.isAdmin)
	return;

	if(mFloor(%i) !$= %i)
	{
		messageClient(%client, '', "Usage: /setTrack <number>");
	return;
	}

	if(%i < 0 || %i > SSK.TrackCount)
	{
		messageClient(%client, '', "serverCmdSetTrack() - out of range index");
		return;
	}

	messageAll('',  "\c5RaceSys\c6:" SPC %client.name SPC "is changing the track.");

	SSK.CurrentTrack = %i - 1;
	SSK_NextTrack();
}

function serverCmdNextTrack(%client, %i)
{
	if(!%client.isAdmin)
		return;

	messageAll('',  "\c5RaceSys\c6:" SPC %client.name SPC "is changing the track.");

	SSK_NextTrack();
}
function player::getVehicleObject(%player)
{
	return %player.getControlObject() | 0;
}
package GameModeSpeedKartPackage
{
	//this is called when save loading finishes 
	function GameModeInitialResetCheck()
	{
		Parent::GameModeInitialResetCheck();

		//if there is no track list, attempt to create it
		if(SSK.TrackCount == 0)
			SSK_BuildTrackList();

		//if tracklist is still empty, there are no tracks
		if(SSK.TrackCount == 0)
		{
			messageAll('',  "\c5RaceSys\c6: Everyone insult the owner for not loading any tracks.");
			return;
		}

		if(SSK.Initialized)
			return;

		SSK.Initialized = true;
		SSK.CurrentTrack = -1;

		SSK_NextTrack();
	}

	//when we're done loading a new track, reset the minigame
	function ServerLoadSaveFile_End()
	{
		Parent::ServerLoadSaveFile_End();

		//new track has loaded, reset minigame
		if($DefaultMiniGame.numMembers > 0) //don't bother if no one is here (this also prevents starting at round 2 on server creation)
		$DefaultMiniGame.scheduleReset(); //don't do it instantly, to give people a little bit of time to ghost

	}

	//when vehicle spawns, it cannot move (event must enable it)
	//this solves the driving through the garage problem
	function WheeledVehicleData::onAdd(%data,%obj)
	{
		Parent::onAdd(%data, %obj);

		for(%i = 0; %i < %data.numWheels; %i++)
			%obj.setWheelPowered(%i, %on);
	}

	//also you cannot click-push a vehicle while it is in non-moving mode
	function vehicle::OnActivate(%vehicle, %activatingObj, %activatingClient, %pos, %vec)
	{
		//just check a wheel
		if(!%vehicle.getWheelPowered(2))
			return;

		Parent::OnActivate(%vehicle, %activatingObj, %activatingClient, %pos, %vec);
	}
	//if smoeone gets back into a garage after the game starts, we don't want them to be able to press a button and respawn someone's cart from under them
	function fxDTSBrick::setVehicle(%obj, %data, %client)
	{
		Parent::setVehicle(%obj, %data, %client);
	}
	function MiniGameSO::Reset(%obj, %client)
	{
		//make sure this value is an number
		SSK.RoundCount = mFloor(SSK.RoundCount);

		//count number of minigame resets, when we reach the limit, go to next track
		if(%obj.numMembers >= 0)
		{
			SSK.ResetCount++;
		}

		if(SSK.ResetCount > SSK.RoundCount)
		{
			SSK.ResetCount = 0;
			SSK_NextTrack();
		}
		else
		{
			messageAll('',  "\c5RaceSys\c6: Get ready, round" SPC SSK.ResetCount SPC "of" SPC SSK.RoundCount SPC "will begin shortly.");
			SSK.resetPlayers(); //Sets player and SSK's value to null because why not.
			Parent::Reset(%obj, %client);
		}
	}
	function overLoadWithObjects()
	{
		for(%i = 0; %i < 5000; %i++)
		{
			%that = new ScriptObject(){};
			echo(%that);
			%that.delete();
		}
	}
	//Where my code begins and Badspot's stops.
	function SSK::resetPlayers(%SSK)
	{
		%cnt = ClientGroup.getCount();
		for(%i=0;%i<%cnt;%i++)
		{
			%client = clientGroup.getObject(%i);
			%client.lap = "";
			%client.checkpoint = "";
			%client.restorePoint = "";
		}
		%SSK.victor = "";
		%SSK.currentLead = "";
	}
	function SSK::runCheckTest(%SSK,%client)
	{
		if(%SSK.currentLead $= "")
		{
			%SSK.currentLead = %client;
			return;
		}
		if(%client.lap > %SSK.currentLead.lap)
		{
			%SSK.currentLead = %client;
		}
		else if(%client.checkpoint > %SSK.currentLead.checkpoint && %client.lap >= %SSK.currentLead.lap)
		{
			%SSK.currentLead = %client;
		}
	}
	function player::damage(%obj, %sourceObject, %position, %damage, %damageType)
	{
		if($DamageType_Array[%damageType] $= "Suicide" && isObject(%obj.getVehicleObject()) && %obj.client.lap !$= "")
			%obj.SSKRespawn();
		else
			parent::damage(%obj, %sourceObject, %position, %damage, %damageType);
	}
	function vehicleData::onEnterLiquid(%a, %obj, %coverage, %type)
	{
		if((%obj.getClassName() $= "WheeledVehicle" || %obj.getClassName() $= "FlyingVehicle" || %obj.getClassName() $= "AIPlayer") && %obj.getControllingObject().client.restorePoint !$= "")
		{
			%player = %obj.getControllingObject();
			if(isObject(%player))
				%player.SSKRespawn(%obj);
		}
		else
		{
			%obj.finalExplosion();
			%obj.getControllingObject().kill();
		}
		parent::onEnterLiquid(%a, %obj, %coverage, %type);
	}
	function player::SSKRespawn(%player)
	{
		%this = %player.client;
		%veh = %player.getVehicleObject();
		%veh.setVelocity("0 0 0");
		%veh.setTransform(%this.restorePoint);
		%veh.setDamageLevel(0);
		if(!isObject(%veh))
		{
			%player.getControlObject().setVelocity("0 0 0");
			%player.getControlObject().setTransform(%this.restorePoint);
			%player.getControlObject().setDamageLevel(0);
		}
	}
	function trigger::lapCheck(%tr,%veh)
	{
		%obj = %veh.getControllingObject();
		%this = %obj.client;
		if(%this.checkpoint $= "")
		{
			%this.checkpoint = %tr.check;
			%this.lap ++;
			%this.restorePoint = %veh.getTransform();
			if(%this.lap <= SSK.LapCount)
			{
				commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC%this.lap@"/"@SSK.LapCount@"\n\c6Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount,3);
				SSK.runCheckTest(%this);
			}
			%tr.brick.onCrossPoint(%veh);
		}
		if((%this.checkpoint + 1) == %tr.check)
		{
			%this.checkpoint++;
			%this.restorePoint = %veh.getTransform();
			commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC %this.lap@"/"@SSK.LapCount@"\n\c6Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount,3);
			SSK.runCheckTest(%this);
			%tr.brick.onCrossPoint(%veh);
		}
		if(%this.checkpoint >= SSK.CheckPointCount && %tr.check == 0)
		{
			%this.checkpoint = %tr.check;
			%this.lap ++;
			%this.restorePoint = %veh.getTransform();
			if(%this.lap <= SSK.LapCount)
			{
				commandToClient(%this,'centerPrint',"<just:right><font:impact:24>\c4Lap\c6:" SPC %this.lap@"/"@SSK.LapCount@"\n\c6Checkpoint\c6:" SPC %this.checkpoint@"/"@SSK.CheckPointCount,3);
				SSK.runCheckTest(%this);
			}
			%tr.brick.onCrossPoint(%veh);
		}
		if(%this.lap > SSK.LapCount && !isObject(SSK.victor))
		{
			%tr.brick.onCrossPoint(%veh);
			%tr.brick.onRaceVictory(%veh);
			%mg = %this.miniGame;
			SSK.victor = %this;
			if(!isObject(%mg))
				%mg = $DefaultMiniGame;

			if(!isObject(%mg))
				return;
			%mg.chatMessageAll(0,  "\c5RaceSys\c6:" SPC %this.name SPC "is the winner!");
			%mg.chatMessageAll(0,  "\c5RaceSys\c6: Everyone else cruise around while you can!");
			%mg.scheduleReset(7000);
		}
	}
	function raceTrigger::onEnterTrigger(%this,%trigger,%obj)
	{
		if(%obj.getClassName() $= "WheeledVehicle" || %obj.getClassName() $= "FlyingVehicle" || %obj.getClassName() $= "AIPlayer")
			%trigger.lapCheck(%obj);
	}
	function brickSpeedkartCheckPointData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function brickSpeedkartStartLineData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function fxDTSBrick::setNTObjectName(%obj,%name)
	{
		if(%obj.getDataBlock().uiName $= "Checkpoint Brick")
		{
			%obj.area.check = %name;
			if(%name > SSK.CheckPointCount)
				SSK.CheckPointCount = %name;
		}
		parent::setNTObjectName(%obj,%name);
		if(%obj.getDataBlock().uiName $= "Checkpoint Brick")
			if(!isObject(%obj.area))
				%obj.createCheckpoint();
	}
	function fxDTSBrick::createCheckpoint(%obj)
	{
		%P1 = getWords(%obj.getWorldBox(),0,2);
		%P2 = getWords(%obj.getWorldBox(),3,5);
		%X1 = getWord(%P1,0);
		%X2 = getWord(%P2,0);
		%Y1 = getWord(%P1,1);
		%Y2 = getWord(%P2,1);
		%Z1 = getWord(%P1,2);
		%Z2 = getWord(%P2,2);
		if(%Y1 + 16 == %Y2)
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z*2;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		else
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z*2;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		%tr = new trigger()
		{
			position = %pos;
			polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
			dataBlock = raceTrigger;
			brick = %obj;
			startLine = false;
			check = 0;
		};
		%tr.setScale(%scale);
		%obj.area = %tr;
		%obj.setNTObjectName(getSubStr(%obj.getName(),1,strlen(%obj.getName())));
		echo("Loaded Checkpoint" SPC %tr.check);
	}
	function fxDTSBrick::createStartLine(%obj)
	{
		%P1 = getWords(%obj.getWorldBox(),0,2);
		%P2 = getWords(%obj.getWorldBox(),3,5);
		%X1 = getWord(%P1,0);
		%X2 = getWord(%P2,0);
		%Y1 = getWord(%P1,1);
		%Y2 = getWord(%P2,1);
		%Z1 = getWord(%P1,2);
		%Z2 = getWord(%P2,2);
		if(%Y1 + 16 == %Y2)
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		else
		{
			%X = detectPos(%X1 - %X2);
			%Y = detectPos(%Y1 - %Y2);
			%Z = detectPos(%Z1 - %Z2);
			%scale = %X SPC %Y SPC (%Z*(3*10))+%Z;
			%pos = %X1 SPC %Y2 SPC %Z2;
		}
		%tr = new trigger()
		{
			position = %pos;
			polyhedron = "0.0 0.0 0.0 1.0 0.0 0.0 0.0 -1.0 0.0 0.0 0.0 1.0";
			dataBlock = raceTrigger;
			brick = %obj;
			startLine = true;	
			check = 0;
		};
		%tr.setScale(%scale);
		%obj.area = %tr;
		echo("Loaded Startpoint");
	}
	function brickSpeedkartStartLineData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartStartLineData.getID())
			%that.schedule(1, createStartLine);
		parent::onPlant(%this,%that);
	}
	function brickSpeedkartCheckPointData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartCheckPointData.getID())
			%that.schedule(1, createCheckpoint);
		parent::onLoadPlant(%this,%that);
	}
	function detectPos(%v)
	{
		if(%v < 0)
		%v *= -1;
		return %v;
	}
	function fxDTSBrick::onRaceVictory(%obj,%vehicle)
	{	
		//obj is the brick!
		if(isObject(%obj.area))
		{
			%DriverClient = "";
			%DriverPlayer = "";
			%VehicleOwnerClient = "";
			%VehicleOwnerPlayer = "";
			%BrickOwnerClient = %obj.getGroup().client;
			%BrickOwnerPlayer = %obj.getGroup().client.player;
			
			//Figure Out Driver---------------------------------
			if(isObject(%vehicle.getControllingClient()))
			{
				%DriverClient = %vehicle.getControllingClient();
			}
			else//the vehicle may be skiis or there is no driver..
			{
				if(isObject(%vehicle.client))
				{
					%DriverClient = %vehicle.client;
				}
				//otherwise leave the DriverClient empty...
			}
			%DriverPlayer = %DriverClient.player;
		
			//Figure Out Owner-----------------------------------
			if(IsObject(%vehicle.brickGroup))
			{
				%OwnerClient = %vehicle.brickGroup.client;
			}
			else//if skiis, Owner is driver..
			{
				if(IsObject(%vehicle.client))
				{
					%OwnerClient = %vehicle.client;
				}
			}
			%OwnerPlayer = %OwnerClient.player;
		
		
		
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Vehicle"] = %vehicle;
			
			
			
			$InputTarget_["Driver(Client)"] = %DriverClient;
			$InputTarget_["Driver(Player)"] = %DriverPlayer;
			
			$InputTarget_["MiniGame"] = %OwnerClient.minigame;
			
			$InputTarget_["Vehicle_Owner(Player)"] = %OwnerPlayer;
			$InputTarget_["Vehicle_Owner(Client)"] = %OwnerClient;
			
			$InputTarget_["Brick_Owner(Client)"] = %BrickOwnerClient;
			$InputTarget_["Brick_Owner(player)"] = %BrickOwnerPlayer;
	
			if(isObject(%DriverClient))//driver client.
			{	
				%obj.processInputEvent("onRaceVictory",%DriverClient);
			}
			else//try the .client field used with skiis - if not settle for brick group owner.
			{
				%obj.processInputEvent("onRaceVictory",%OwnerClient);
			}
		}
		
	}
	function fxDTSBrick::onCrossPoint(%obj,%vehicle)
	{	
		//obj is the brick!
		if(isObject(%obj.area))
		{
			%DriverClient = "";
			%DriverPlayer = "";
			%VehicleOwnerClient = "";
			%VehicleOwnerPlayer = "";
			%BrickOwnerClient = %obj.getGroup().client;
			%BrickOwnerPlayer = %obj.getGroup().client.player;
			
			//Figure Out Driver---------------------------------
			if(isObject(%vehicle.getControllingClient()))
			{
				%DriverClient = %vehicle.getControllingClient();
			}
			else//the vehicle may be skiis or there is no driver..
			{
				if(isObject(%vehicle.client))
				{
					%DriverClient = %vehicle.client;
				}
				//otherwise leave the DriverClient empty...
			}
			%DriverPlayer = %DriverClient.player;
		
			//Figure Out Owner-----------------------------------
			if(IsObject(%vehicle.brickGroup))
			{
				%OwnerClient = %vehicle.brickGroup.client;
			}
			else//if skiis, Owner is driver..
			{
				if(IsObject(%vehicle.client))
				{
					%OwnerClient = %vehicle.client;
				}
			}
			%OwnerPlayer = %OwnerClient.player;
		
		
		
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Vehicle"] = %vehicle;
			
			
			
			$InputTarget_["Driver(Client)"] = %DriverClient;
			$InputTarget_["Driver(Player)"] = %DriverPlayer;
			
			$InputTarget_["MiniGame"] = %OwnerClient.minigame;
			
			$InputTarget_["Vehicle_Owner(Player)"] = %OwnerPlayer;
			$InputTarget_["Vehicle_Owner(Client)"] = %OwnerClient;
			
			$InputTarget_["Brick_Owner(Client)"] = %BrickOwnerClient;
			$InputTarget_["Brick_Owner(player)"] = %BrickOwnerPlayer;
	
			if(isObject(%DriverClient))//driver client.
			{	
				%obj.processInputEvent("onCrossPoint",%DriverClient);
			}
			else//try the .client field used with skiis - if not settle for brick group owner.
			{
				%obj.processInputEvent("onCrossPoint",%OwnerClient);
			}
		}
		
	}
	function Vehicle::changeVehicle(%this,%that)
	{
		%this.setDataBlock(%that);
		for(%i = 0; %i < %this.getWheelCount(); %i ++)
		{
			%this.setWheelSpring(%i,%that.defaultSpring);
			%this.setWheelTire(%i,%that.defaultTire);
		}
		%that.onAdd(%this);
	}
	function Armor::onMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f)
	{
		%this.restorePoint = %obj.getTransform();
		Parent::onMount(%this,%player,%obj,%a,%b,%c,%d,%e,%f);
	}
	function Armor::DoDismount(%this,%player)
	{
		if(isObject(SSK) && isObject(%player.client.minigame))
		{
			%player.checkpointRespawn();
			return;
		}
		parent::DoDismount(%this,%player);
	}
	function Vehicle::checkpointRespawn(%this)
	{
		%player = %this.getControllingObject();
		%player.SSKRespawn();
	}
	function player::checkpointRespawn(%this)
	{
		%this.SSKRespawn();
	}
};

if($GameModeArg $= "Add-Ons/Gamemode_SuperKart/gamemode.txt")
	activatePackage(GameModeSpeedKartPackage);

//special event to explode vehicles that are left in the garage
registerOutputEvent("fxDTSBrick", "explodeNearVehicle", "");
function fxDTSBrick::explodeNearVehicle(%obj)
{
	%vehicle = %obj.vehicle;
	if(!isObject(%vehicle))
		return;

	%delta = vectorSub(%vehicle.getPosition(), %obj.getPosition());
	//echo("len = " @ vectorLen(%delta));
	if(vectorLen(%delta) < 5) //7.5)
		%vehicle.finalExplosion(); //damage(%vehicle, %vehicle.getPosition(), 10000, $DamageType::Default);
}

//highly important sound effect
datablock AudioProfile(SSK_gwScream)
{
	filename    = "./gw_scream.wav";
	description = AudioDefault3d;
	preload = true;
};